package sun.security.acl;

import java.util.Enumeration;
import java.security.Principal;
import java.util.Vector;
import java.security.acl.Group;

public class GroupImpl implements Group
{
    private Vector<Principal> groupMembers;
    private String group;
    
    public GroupImpl(String group) {
        this.groupMembers = new Vector(50, 100);
        this.group = group;
    }
    
    public boolean addMember(Principal principal) {
        if (this.groupMembers.contains(principal)) {
            return false;
        }
        if (this.group.equals(principal.toString())) {
            throw new IllegalArgumentException();
        }
        this.groupMembers.addElement(principal);
        return true;
    }
    
    public boolean removeMember(Principal obj) {
        return this.groupMembers.removeElement(obj);
    }
    
    public Enumeration<? extends Principal> members() {
        return this.groupMembers.elements();
    }
    
    @Override
    public boolean equals(Object o) {
        return this == o || (o instanceof Group && this.group.equals(((Object)o).toString()));
    }
    
    public boolean equals(Group group) {
        return this.equals(group);
    }
    
    @Override
    public String toString() {
        return this.group;
    }
    
    @Override
    public int hashCode() {
        return this.group.hashCode();
    }
    
    public boolean isMember(Principal o) {
        return this.groupMembers.contains(o) || this.isMemberRecurse(o, new Vector(10));
    }
    
    public String getName() {
        return this.group;
    }
    
    boolean isMemberRecurse(Principal principal, Vector<Group> vector) {
        Enumeration<Object> members = this.members();
        while (members.hasMoreElements()) {
            boolean n = false;
            Principal principal2 = (Principal)members.nextElement();
            if (principal2.equals(principal)) {
                return true;
            }
            if ((principal2 instanceof GroupImpl)) {
                GroupImpl o2 = (GroupImpl)principal2;
                vector.addElement(this);
                if (!vector.contains(o2)) {
                    n = o2.isMemberRecurse(principal, vector);
                }
            }
            else if ((principal2 instanceof Group)) {
                Group o = (Group)principal2;
                if (!vector.contains(o)) {
                    n = o.isMember(principal);
                }
            }
            if (!(n == 0)) {
                return n;
            }
            continue;
        }
        return false;
    }
}
